    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ------------------
    028     * KeyedValues2D.java
    029     * ------------------
    030     * (C) Copyright 2002-2005, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: KeyedValues2D.java,v 1.3.2.2 2005/10/25 21:29:13 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 28-Oct-2002 : Version 1 (DG);
    040     * 12-Jan-2005 : Updated Javadocs (DG);
    041     *
    042     */
    043
    044    package org.jfree.data;
    045
    046    import java.util.List;
    047
    048    /**
    049     * An extension of the {@link Values2D} interface where a unique key is
    050     * associated with the row and column indices.
    051     */
    052    public interface KeyedValues2D extends Values2D {
    053
    054        /**
    055         * Returns the row key for a given index.
    056         *
    057         * @param row  the row index (zero-based).
    058         *
    059         * @return The row key.
    060         *
    061         * @throws IndexOutOfBoundsException if <code>row</code> is out of bounds.
    062         */
    063        public Comparable getRowKey(int row);
    064
    065        /**
    066         * Returns the row index for a given key.
    067         *
    068         * @param key  the row key.
    069         *
    070         * @return The row index, or <code>-1</code> if the key is unrecognised.
    071         */
    072        public int getRowIndex(Comparable key);
    073
    074        /**
    075         * Returns the row keys.
    076         *
    077         * @return The keys.
    078         */
    079        public List getRowKeys();
    080
    081        /**
    082         * Returns the column key for a given index.
    083         *
    084         * @param column  the column index (zero-based).
    085         *
    086         * @return The column key.
    087         *
    088         * @throws IndexOutOfBoundsException if <code>row</code> is out of bounds.
    089         */
    090        public Comparable getColumnKey(int column);
    091
    092        /**
    093         * Returns the column index for a given key.
    094         *
    095         * @param key  the column key.
    096         *
    097         * @return The column index, or <code>-1</code> if the key is unrecognised.
    098         */
    099        public int getColumnIndex(Comparable key);
    100
    101        /**
    102         * Returns the column keys.
    103         *
    104         * @return The keys.
    105         */
    106        public List getColumnKeys();
    107
    108        /**
    109         * Returns the value associated with the specified keys.
    110         *
    111         * @param rowKey  the row key (<code>null</code> not permitted).
    112         * @param columnKey  the column key (<code>null</code> not permitted).
    113         *
    114         * @return The value.
    115         *
    116         * @throws UnknownKeyException if either key is not recognised.
    117         */
    118        public Number getValue(Comparable rowKey, Comparable columnKey);
    119
    120    }